// Compiled by ClojureScript 1.9.14 {:static-fns true, :optimize-constants true}
goog.provide('awesome_app.core');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('clojure.zip');
goog.require('clojure.set');
goog.require('cljs.reader');
awesome_app.core.now = (function awesome_app$core$now(){
return (new Date()).getTime();
});
awesome_app.core.rs = (function awesome_app$core$rs(s){
return cljs.reader.read_string(s);
});
/**
 * Indexes into the enumeration of non-negative integer pairs using the 
 *   diagonal method often used to enumerate the rationals, except that everything
 *   is zero-based and we don't actually divide.
 */
awesome_app.core.number_to_pair = (function awesome_app$core$number_to_pair(n){
var numerator = (0);
var denominator = (0);
var count = (0);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(count,n)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [numerator,denominator], null);
} else {
if((numerator === (0))){
var G__13165 = (denominator + (1));
var G__13166 = (0);
var G__13167 = (count + (1));
numerator = G__13165;
denominator = G__13166;
count = G__13167;
continue;
} else {
var G__13168 = (numerator - (1));
var G__13169 = (denominator + (1));
var G__13170 = (count + (1));
numerator = G__13168;
denominator = G__13169;
count = G__13170;
continue;
}
}
break;
}
});
awesome_app.core.indexed_term = (function awesome_app$core$indexed_term(i){
var G__13173 = i;
switch (G__13173) {
case (0):
return cljs.core.cst$sym$x;

break;
case (1):
return cljs.core.cst$sym$y;

break;
case (2):
return cljs.core.cst$sym$z;

break;
default:
var vec__13174 = awesome_app.core.number_to_pair((i - (3)));
var left = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__13174,(0),null);
var right = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__13174,(1),null);
return cljs.core._conj((function (){var x__7050__auto__ = awesome_app$core$indexed_term(left);
return cljs.core._conj((function (){var x__7050__auto____$1 = awesome_app$core$indexed_term(right);
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);

}
});
/**
 * Each call consumes one index and sets the value, returning the modified term source.
 */
awesome_app.core.next_term = (function awesome_app$core$next_term(p__13176){
var map__13180 = p__13176;
var map__13180__$1 = ((((!((map__13180 == null)))?((((map__13180.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13180.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__13180):map__13180);
var base = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__13180__$1,cljs.core.cst$kw$base);
var step = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__13180__$1,cljs.core.cst$kw$step);
var indices = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__13180__$1,cljs.core.cst$kw$indices);
if(cljs.core.empty_QMARK_(indices)){
return awesome_app$core$next_term(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$base,(base + step),cljs.core.cst$kw$step,step,cljs.core.cst$kw$indices,cljs.core.shuffle(cljs.core.range.cljs$core$IFn$_invoke$arity$2(base,(base + step))),cljs.core.cst$kw$value,null], null));
} else {
return new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$base,base,cljs.core.cst$kw$step,step,cljs.core.cst$kw$indices,cljs.core.rest(indices),cljs.core.cst$kw$value,awesome_app.core.indexed_term(cljs.core.first(indices))], null);
}
});
awesome_app.core.term_source = (function awesome_app$core$term_source(step){
return awesome_app.core.next_term(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$base,(0),cljs.core.cst$kw$step,step,cljs.core.cst$kw$indices,cljs.core.PersistentVector.EMPTY,cljs.core.cst$kw$value,null], null));
});
awesome_app.core.num_vars = (function awesome_app$core$num_vars(t){
return cljs.core.count(cljs.core.filter.cljs$core$IFn$_invoke$arity$2((function (p1__13182_SHARP_){
return cljs.core.some(cljs.core.PersistentHashSet.fromArray([p1__13182_SHARP_], true),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$sym$y,null,cljs.core.cst$sym$x,null,cljs.core.cst$sym$z,null], null), null));
}),cljs.core.flatten(t)));
});
awesome_app.core.codesize = (function awesome_app$core$codesize(c){
if(cljs.core.seq_QMARK_(c)){
return cljs.core.count(cljs.core.flatten(c));
} else {
return (1);
}
});
/**
 * Returns a subtree of tree indexed by point-index in a depth first traversal.
 */
awesome_app.core.at_index = (function awesome_app$core$at_index(tree,point_index){
var index = cljs.core.mod(Math.abs(point_index),awesome_app.core.codesize(tree));
var zipper = clojure.zip.seq_zip(tree);
var z = zipper;
var i = index;
while(true){
if((i === (0))){
return clojure.zip.node(z);
} else {
if(cljs.core.seq_QMARK_(clojure.zip.node(z))){
var G__13183 = clojure.zip.next(clojure.zip.next(z));
var G__13184 = (i - (1));
z = G__13183;
i = G__13184;
continue;
} else {
var G__13185 = clojure.zip.next(z);
var G__13186 = (i - (1));
z = G__13185;
i = G__13186;
continue;
}
}
break;
}
});
/**
 * Returns a copy of tree with the subtree formerly indexed by
 *   point-index (in a depth-first traversal) replaced by new-subtree.
 */
awesome_app.core.insert_at_index = (function awesome_app$core$insert_at_index(tree,point_index,new_subtree){
var index = cljs.core.mod(Math.abs(point_index),awesome_app.core.codesize(tree));
var zipper = clojure.zip.seq_zip(tree);
var z = zipper;
var i = index;
while(true){
if((i === (0))){
return clojure.zip.root(clojure.zip.replace(z,new_subtree));
} else {
if(cljs.core.seq_QMARK_(clojure.zip.node(z))){
var G__13187 = clojure.zip.next(clojure.zip.next(z));
var G__13188 = (i - (1));
z = G__13187;
i = G__13188;
continue;
} else {
var G__13189 = clojure.zip.next(z);
var G__13190 = (i - (1));
z = G__13189;
i = G__13190;
continue;
}
}
break;
}
});
awesome_app.core.expand = (function awesome_app$core$expand(t){
var i = cljs.core.rand_int(awesome_app.core.codesize(t));
return awesome_app.core.insert_at_index(t,i,cljs.core.cons(cljs.core.cst$sym$_STAR_,cljs.core.shuffle(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [awesome_app.core.at_index(t,i),cljs.core.rand_nth(cljs.core.list(cljs.core.cst$sym$x,cljs.core.cst$sym$y,cljs.core.cst$sym$z))], null))));
});
/**
 * Returns a random term generated using the grow algorithm.
 */
awesome_app.core.bud_term = (function awesome_app$core$bud_term(vars){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(vars,(1))){
return cljs.core.rand_nth(cljs.core.list(cljs.core.cst$sym$x,cljs.core.cst$sym$y,cljs.core.cst$sym$z));
} else {
var t = cljs.core._conj((function (){var x__7050__auto__ = cljs.core.rand_nth(cljs.core.list(cljs.core.cst$sym$x,cljs.core.cst$sym$y,cljs.core.cst$sym$z));
return cljs.core._conj((function (){var x__7050__auto____$1 = cljs.core.rand_nth(cljs.core.list(cljs.core.cst$sym$x,cljs.core.cst$sym$y,cljs.core.cst$sym$z));
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);
while(true){
if((awesome_app.core.num_vars(t) >= vars)){
return t;
} else {
var G__13191 = awesome_app.core.expand(t);
t = G__13191;
continue;
}
break;
}
}
});
awesome_app.core.a1 = cljs.core.list(cljs.core.list((2),(1),(2)),cljs.core.list((1),(0),(0)),cljs.core.list((0),(0),(1)));
awesome_app.core.a2 = cljs.core.list(cljs.core.list((2),(0),(2)),cljs.core.list((1),(0),(2)),cljs.core.list((1),(2),(1)));
awesome_app.core.a3 = cljs.core.list(cljs.core.list((1),(0),(1)),cljs.core.list((1),(2),(0)),cljs.core.list((0),(0),(0)));
awesome_app.core.a4 = cljs.core.list(cljs.core.list((1),(0),(1)),cljs.core.list((0),(2),(0)),cljs.core.list((0),(1),(0)));
awesome_app.core.a5 = cljs.core.list(cljs.core.list((1),(0),(2)),cljs.core.list((1),(2),(0)),cljs.core.list((0),(1),(0)));
awesome_app.core.b1 = cljs.core.list(cljs.core.list((1),(3),(1),(0)),cljs.core.list((3),(2),(0),(1)),cljs.core.list((0),(1),(3),(1)),cljs.core.list((1),(0),(2),(0)));
awesome_app.core.b2 = cljs.core.list(cljs.core.list((2),(1),(0),(3)),cljs.core.list((1),(0),(1),(3)),cljs.core.list((1),(0),(3),(0)),cljs.core.list((3),(1),(3),(1)));
awesome_app.core.b3 = cljs.core.list(cljs.core.list((2),(2),(1),(0)),cljs.core.list((0),(2),(3),(3)),cljs.core.list((2),(0),(3),(2)),cljs.core.list((0),(0),(3),(0)));
awesome_app.core.p1 = cljs.core.list(cljs.core.list((3),(2),(0),(4),(0)),cljs.core.list((2),(4),(1),(1),(1)),cljs.core.list((1),(1),(3),(0),(1)),cljs.core.list((1),(3),(4),(1),(0)),cljs.core.list((0),(1),(0),(1),(0)));
awesome_app.core.p2 = cljs.core.list(cljs.core.list((2),(1),(2),(4),(1)),cljs.core.list((0),(4),(4),(1),(4)),cljs.core.list((0),(4),(4),(1),(3)),cljs.core.list((1),(1),(2),(1),(3)),cljs.core.list((1),(1),(0),(0),(3)));
awesome_app.core.i1 = cljs.core.list(cljs.core.list((1),(3),(0),(4),(1)),cljs.core.list((1),(0),(3),(3),(0)),cljs.core.list((3),(4),(3),(0),(1)),cljs.core.list((4),(4),(0),(1),(2)),cljs.core.list((0),(3),(1),(4),(4)));
awesome_app.core.i2 = cljs.core.list(cljs.core.list((2),(3),(2),(2),(1)),cljs.core.list((2),(1),(2),(3),(3)),cljs.core.list((1),(3),(4),(3),(3)),cljs.core.list((0),(4),(0),(1),(1)),cljs.core.list((3),(2),(4),(1),(1)));
awesome_app.core.i3 = cljs.core.list(cljs.core.list((1),(3),(4),(3),(3)),cljs.core.list((3),(2),(1),(4),(0)),cljs.core.list((3),(1),(0),(2),(2)),cljs.core.list((4),(2),(3),(3),(1)),cljs.core.list((2),(2),(4),(1),(1)));
awesome_app.core.i4 = cljs.core.list(cljs.core.list((0),(3),(2),(1),(3)),cljs.core.list((0),(4),(1),(1),(2)),cljs.core.list((3),(4),(3),(2),(0)),cljs.core.list((0),(0),(0),(1),(1)),cljs.core.list((0),(4),(1),(3),(1)));
awesome_app.core.d1 = cljs.core.list(cljs.core.list((1),(4),(0),(1),(3),(0)),cljs.core.list((3),(2),(1),(2),(0),(4)),cljs.core.list((2),(0),(3),(5),(1),(3)),cljs.core.list((5),(2),(0),(4),(2),(0)),cljs.core.list((2),(1),(3),(0),(5),(1)),cljs.core.list((0),(2),(1),(1),(4),(0)));
awesome_app.core.e1 = cljs.core.list(cljs.core.list((2),(1),(0),(2),(0),(4),(2)),cljs.core.list((4),(5),(0),(3),(3),(3),(0)),cljs.core.list((1),(0),(3),(2),(4),(1),(2)),cljs.core.list((0),(4),(3),(1),(2),(5),(1)),cljs.core.list((2),(0),(1),(4),(6),(6),(4)),cljs.core.list((0),(6),(2),(4),(3),(4),(2)),cljs.core.list((5),(6),(1),(0),(0),(3),(0)));
/**
 * Takes a left operation and a right operation and returns the operation of
 *   combining them with the given groupoid.
 */
awesome_app.core.merge_operations = (function awesome_app$core$merge_operations(left_operation,right_operation){
return cljs.core.map.cljs$core$IFn$_invoke$arity$3((function (p1__13192_SHARP_,p2__13193_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(cljs.core.nth.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$groupoid.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params))),p1__13192_SHARP_),p2__13193_SHARP_);
}),left_operation,right_operation);
});
awesome_app.core.term_operation = cljs.core.memoize((function (term){
var sz = cljs.core.count(cljs.core.cst$kw$groupoid.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params))));
if(typeof term === 'number'){
return cljs.core.repeat.cljs$core$IFn$_invoke$arity$2(((sz * sz) * sz),term);
} else {
if((term instanceof cljs.core.Symbol)){
var iter__6996__auto__ = ((function (sz){
return (function awesome_app$core$iter__13194(s__13195){
return (new cljs.core.LazySeq(null,((function (sz){
return (function (){
var s__13195__$1 = s__13195;
while(true){
var temp__4657__auto__ = cljs.core.seq(s__13195__$1);
if(temp__4657__auto__){
var xs__5205__auto__ = temp__4657__auto__;
var x = cljs.core.first(xs__5205__auto__);
var iterys__6992__auto__ = ((function (s__13195__$1,x,xs__5205__auto__,temp__4657__auto__,sz){
return (function awesome_app$core$iter__13194_$_iter__13196(s__13197){
return (new cljs.core.LazySeq(null,((function (s__13195__$1,x,xs__5205__auto__,temp__4657__auto__,sz){
return (function (){
var s__13197__$1 = s__13197;
while(true){
var temp__4657__auto____$1 = cljs.core.seq(s__13197__$1);
if(temp__4657__auto____$1){
var xs__5205__auto____$1 = temp__4657__auto____$1;
var y = cljs.core.first(xs__5205__auto____$1);
var iterys__6992__auto__ = ((function (s__13197__$1,s__13195__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,sz){
return (function awesome_app$core$iter__13194_$_iter__13196_$_iter__13198(s__13199){
return (new cljs.core.LazySeq(null,((function (s__13197__$1,s__13195__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,sz){
return (function (){
var s__13199__$1 = s__13199;
while(true){
var temp__4657__auto____$2 = cljs.core.seq(s__13199__$1);
if(temp__4657__auto____$2){
var s__13199__$2 = temp__4657__auto____$2;
if(cljs.core.chunked_seq_QMARK_(s__13199__$2)){
var c__6994__auto__ = cljs.core.chunk_first(s__13199__$2);
var size__6995__auto__ = cljs.core.count(c__6994__auto__);
var b__13201 = cljs.core.chunk_buffer(size__6995__auto__);
if((function (){var i__13200 = (0);
while(true){
if((i__13200 < size__6995__auto__)){
var z = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__6994__auto__,i__13200);
cljs.core.chunk_append(b__13201,(function (){var G__13227 = term;
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$x,G__13227)){
return x;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$y,G__13227)){
return y;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$z,G__13227)){
return z;
} else {
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(term)].join('')));

}
}
}
})());

var G__13231 = (i__13200 + (1));
i__13200 = G__13231;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__13201),awesome_app$core$iter__13194_$_iter__13196_$_iter__13198(cljs.core.chunk_rest(s__13199__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__13201),null);
}
} else {
var z = cljs.core.first(s__13199__$2);
return cljs.core.cons((function (){var G__13228 = term;
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$x,G__13228)){
return x;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$y,G__13228)){
return y;
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$z,G__13228)){
return z;
} else {
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(term)].join('')));

}
}
}
})(),awesome_app$core$iter__13194_$_iter__13196_$_iter__13198(cljs.core.rest(s__13199__$2)));
}
} else {
return null;
}
break;
}
});})(s__13197__$1,s__13195__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,sz))
,null,null));
});})(s__13197__$1,s__13195__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,sz))
;
var fs__6993__auto__ = cljs.core.seq(iterys__6992__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(sz)));
if(fs__6993__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__6993__auto__,awesome_app$core$iter__13194_$_iter__13196(cljs.core.rest(s__13197__$1)));
} else {
var G__13232 = cljs.core.rest(s__13197__$1);
s__13197__$1 = G__13232;
continue;
}
} else {
return null;
}
break;
}
});})(s__13195__$1,x,xs__5205__auto__,temp__4657__auto__,sz))
,null,null));
});})(s__13195__$1,x,xs__5205__auto__,temp__4657__auto__,sz))
;
var fs__6993__auto__ = cljs.core.seq(iterys__6992__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(sz)));
if(fs__6993__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__6993__auto__,awesome_app$core$iter__13194(cljs.core.rest(s__13195__$1)));
} else {
var G__13233 = cljs.core.rest(s__13195__$1);
s__13195__$1 = G__13233;
continue;
}
} else {
return null;
}
break;
}
});})(sz))
,null,null));
});})(sz))
;
return iter__6996__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(sz));
} else {
return awesome_app.core.merge_operations((function (){var G__13229 = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(term,(1));
return (awesome_app.core.term_operation.cljs$core$IFn$_invoke$arity$1 ? awesome_app.core.term_operation.cljs$core$IFn$_invoke$arity$1(G__13229) : awesome_app.core.term_operation.call(null,G__13229));
})(),(function (){var G__13230 = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(term,(2));
return (awesome_app.core.term_operation.cljs$core$IFn$_invoke$arity$1 ? awesome_app.core.term_operation.cljs$core$IFn$_invoke$arity$1(G__13230) : awesome_app.core.term_operation.call(null,G__13230));
})());

}
}
}));
/**
 * Returns a sequence of sets of acceptable answers for each binding list in
 *   lexicographic order of xyz (with z varying the most quickly), for a discriminator
 *   term of the given groupoid.
 */
awesome_app.core.discriminator_constraints = (function awesome_app$core$discriminator_constraints(g){
var n = cljs.core.count(cljs.core.first(g));
return cljs.core.vec((function (){var iter__6996__auto__ = ((function (n){
return (function awesome_app$core$discriminator_constraints_$_iter__13253(s__13254){
return (new cljs.core.LazySeq(null,((function (n){
return (function (){
var s__13254__$1 = s__13254;
while(true){
var temp__4657__auto__ = cljs.core.seq(s__13254__$1);
if(temp__4657__auto__){
var xs__5205__auto__ = temp__4657__auto__;
var x = cljs.core.first(xs__5205__auto__);
var iterys__6992__auto__ = ((function (s__13254__$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function awesome_app$core$discriminator_constraints_$_iter__13253_$_iter__13255(s__13256){
return (new cljs.core.LazySeq(null,((function (s__13254__$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function (){
var s__13256__$1 = s__13256;
while(true){
var temp__4657__auto____$1 = cljs.core.seq(s__13256__$1);
if(temp__4657__auto____$1){
var xs__5205__auto____$1 = temp__4657__auto____$1;
var y = cljs.core.first(xs__5205__auto____$1);
var iterys__6992__auto__ = ((function (s__13256__$1,s__13254__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function awesome_app$core$discriminator_constraints_$_iter__13253_$_iter__13255_$_iter__13257(s__13258){
return (new cljs.core.LazySeq(null,((function (s__13256__$1,s__13254__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function (){
var s__13258__$1 = s__13258;
while(true){
var temp__4657__auto____$2 = cljs.core.seq(s__13258__$1);
if(temp__4657__auto____$2){
var s__13258__$2 = temp__4657__auto____$2;
if(cljs.core.chunked_seq_QMARK_(s__13258__$2)){
var c__6994__auto__ = cljs.core.chunk_first(s__13258__$2);
var size__6995__auto__ = cljs.core.count(c__6994__auto__);
var b__13260 = cljs.core.chunk_buffer(size__6995__auto__);
if((function (){var i__13259 = (0);
while(true){
if((i__13259 < size__6995__auto__)){
var z = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__6994__auto__,i__13259);
cljs.core.chunk_append(b__13260,cljs.core.PersistentHashSet.fromArray([(((x === y))?z:x)], true));

var G__13272 = (i__13259 + (1));
i__13259 = G__13272;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__13260),awesome_app$core$discriminator_constraints_$_iter__13253_$_iter__13255_$_iter__13257(cljs.core.chunk_rest(s__13258__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__13260),null);
}
} else {
var z = cljs.core.first(s__13258__$2);
return cljs.core.cons(cljs.core.PersistentHashSet.fromArray([(((x === y))?z:x)], true),awesome_app$core$discriminator_constraints_$_iter__13253_$_iter__13255_$_iter__13257(cljs.core.rest(s__13258__$2)));
}
} else {
return null;
}
break;
}
});})(s__13256__$1,s__13254__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n))
,null,null));
});})(s__13256__$1,s__13254__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n))
;
var fs__6993__auto__ = cljs.core.seq(iterys__6992__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n)));
if(fs__6993__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__6993__auto__,awesome_app$core$discriminator_constraints_$_iter__13253_$_iter__13255(cljs.core.rest(s__13256__$1)));
} else {
var G__13273 = cljs.core.rest(s__13256__$1);
s__13256__$1 = G__13273;
continue;
}
} else {
return null;
}
break;
}
});})(s__13254__$1,x,xs__5205__auto__,temp__4657__auto__,n))
,null,null));
});})(s__13254__$1,x,xs__5205__auto__,temp__4657__auto__,n))
;
var fs__6993__auto__ = cljs.core.seq(iterys__6992__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n)));
if(fs__6993__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__6993__auto__,awesome_app$core$discriminator_constraints_$_iter__13253(cljs.core.rest(s__13254__$1)));
} else {
var G__13274 = cljs.core.rest(s__13254__$1);
s__13254__$1 = G__13274;
continue;
}
} else {
return null;
}
break;
}
});})(n))
,null,null));
});})(n))
;
return iter__6996__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n));
})());
});
/**
 * Returns a sequence of sets of acceptable answers for each binding list in
 *   lexicographic order of xyz (with z varying the most quickly), for a discriminator
 *   term of the given groupoid.
 */
awesome_app.core.malcev_constraints = (function awesome_app$core$malcev_constraints(g){
var n = cljs.core.count(cljs.core.first(g));
return cljs.core.vec((function (){var iter__6996__auto__ = ((function (n){
return (function awesome_app$core$malcev_constraints_$_iter__13294(s__13295){
return (new cljs.core.LazySeq(null,((function (n){
return (function (){
var s__13295__$1 = s__13295;
while(true){
var temp__4657__auto__ = cljs.core.seq(s__13295__$1);
if(temp__4657__auto__){
var xs__5205__auto__ = temp__4657__auto__;
var x = cljs.core.first(xs__5205__auto__);
var iterys__6992__auto__ = ((function (s__13295__$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function awesome_app$core$malcev_constraints_$_iter__13294_$_iter__13296(s__13297){
return (new cljs.core.LazySeq(null,((function (s__13295__$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function (){
var s__13297__$1 = s__13297;
while(true){
var temp__4657__auto____$1 = cljs.core.seq(s__13297__$1);
if(temp__4657__auto____$1){
var xs__5205__auto____$1 = temp__4657__auto____$1;
var y = cljs.core.first(xs__5205__auto____$1);
var iterys__6992__auto__ = ((function (s__13297__$1,s__13295__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function awesome_app$core$malcev_constraints_$_iter__13294_$_iter__13296_$_iter__13298(s__13299){
return (new cljs.core.LazySeq(null,((function (s__13297__$1,s__13295__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n){
return (function (){
var s__13299__$1 = s__13299;
while(true){
var temp__4657__auto____$2 = cljs.core.seq(s__13299__$1);
if(temp__4657__auto____$2){
var s__13299__$2 = temp__4657__auto____$2;
if(cljs.core.chunked_seq_QMARK_(s__13299__$2)){
var c__6994__auto__ = cljs.core.chunk_first(s__13299__$2);
var size__6995__auto__ = cljs.core.count(c__6994__auto__);
var b__13301 = cljs.core.chunk_buffer(size__6995__auto__);
if((function (){var i__13300 = (0);
while(true){
if((i__13300 < size__6995__auto__)){
var z = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__6994__auto__,i__13300);
cljs.core.chunk_append(b__13301,(((x === y))?cljs.core.PersistentHashSet.fromArray([z], true):(((y === z))?cljs.core.PersistentHashSet.fromArray([x], true):cljs.core.set(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n)))));

var G__13313 = (i__13300 + (1));
i__13300 = G__13313;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__13301),awesome_app$core$malcev_constraints_$_iter__13294_$_iter__13296_$_iter__13298(cljs.core.chunk_rest(s__13299__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__13301),null);
}
} else {
var z = cljs.core.first(s__13299__$2);
return cljs.core.cons((((x === y))?cljs.core.PersistentHashSet.fromArray([z], true):(((y === z))?cljs.core.PersistentHashSet.fromArray([x], true):cljs.core.set(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n)))),awesome_app$core$malcev_constraints_$_iter__13294_$_iter__13296_$_iter__13298(cljs.core.rest(s__13299__$2)));
}
} else {
return null;
}
break;
}
});})(s__13297__$1,s__13295__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n))
,null,null));
});})(s__13297__$1,s__13295__$1,y,xs__5205__auto____$1,temp__4657__auto____$1,x,xs__5205__auto__,temp__4657__auto__,n))
;
var fs__6993__auto__ = cljs.core.seq(iterys__6992__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n)));
if(fs__6993__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__6993__auto__,awesome_app$core$malcev_constraints_$_iter__13294_$_iter__13296(cljs.core.rest(s__13297__$1)));
} else {
var G__13314 = cljs.core.rest(s__13297__$1);
s__13297__$1 = G__13314;
continue;
}
} else {
return null;
}
break;
}
});})(s__13295__$1,x,xs__5205__auto__,temp__4657__auto__,n))
,null,null));
});})(s__13295__$1,x,xs__5205__auto__,temp__4657__auto__,n))
;
var fs__6993__auto__ = cljs.core.seq(iterys__6992__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n)));
if(fs__6993__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__6993__auto__,awesome_app$core$malcev_constraints_$_iter__13294(cljs.core.rest(s__13295__$1)));
} else {
var G__13315 = cljs.core.rest(s__13295__$1);
s__13295__$1 = G__13315;
continue;
}
} else {
return null;
}
break;
}
});})(n))
,null,null));
});})(n))
;
return iter__6996__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(n));
})());
});
/**
 * Returns a sequence of errors for each binding list in lexicographic order 
 *   of xyz (with z varying the most quickly), for the term relative to the 
 *   constraints. If the term produces a value consistent with the constraints
 *   for a binding list then the error will be 0, otherwise it will be 1.
 */
awesome_app.core.term_errors = (function awesome_app$core$term_errors(term,constraints){
return cljs.core.map.cljs$core$IFn$_invoke$arity$3((function (answer,allowed){
if(cljs.core.truth_(cljs.core.some(cljs.core.PersistentHashSet.fromArray([answer], true),allowed))){
return (0);
} else {
return (1);
}
}),(awesome_app.core.term_operation.cljs$core$IFn$_invoke$arity$1 ? awesome_app.core.term_operation.cljs$core$IFn$_invoke$arity$1(term) : awesome_app.core.term_operation.call(null,term)),constraints);
});
/**
 * Returns a sequence of acceptable values (constraints) for each binding list in
 *   lexicographic order of xyz (with z varying the most quickly), relative to the
 *   specified overall (parent) constraints, for the second side of a term if the
 *   specified first side is filled with the specified term.
 */
awesome_app.core.side2_constraints = (function awesome_app$core$side2_constraints(side1,side1_term,parent_constraints){
var g = cljs.core.cst$kw$groupoid.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params)));
var error_sequences = (function (){var sz = cljs.core.count(g);
var iter__6996__auto__ = ((function (sz,g){
return (function awesome_app$core$side2_constraints_$_iter__13327(s__13328){
return (new cljs.core.LazySeq(null,((function (sz,g){
return (function (){
var s__13328__$1 = s__13328;
while(true){
var temp__4657__auto__ = cljs.core.seq(s__13328__$1);
if(temp__4657__auto__){
var s__13328__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_(s__13328__$2)){
var c__6994__auto__ = cljs.core.chunk_first(s__13328__$2);
var size__6995__auto__ = cljs.core.count(c__6994__auto__);
var b__13330 = cljs.core.chunk_buffer(size__6995__auto__);
if((function (){var i__13329 = (0);
while(true){
if((i__13329 < size__6995__auto__)){
var lz = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__6994__auto__,i__13329);
cljs.core.chunk_append(b__13330,awesome_app.core.term_errors((function (){var G__13335 = (((side1 instanceof cljs.core.Keyword))?side1.fqn:null);
switch (G__13335) {
case "left":
return cljs.core._conj((function (){var x__7050__auto__ = side1_term;
return cljs.core._conj((function (){var x__7050__auto____$1 = lz;
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);

break;
case "right":
return cljs.core._conj((function (){var x__7050__auto__ = lz;
return cljs.core._conj((function (){var x__7050__auto____$1 = side1_term;
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(side1)].join('')));

}
})(),parent_constraints));

var G__13338 = (i__13329 + (1));
i__13329 = G__13338;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__13330),awesome_app$core$side2_constraints_$_iter__13327(cljs.core.chunk_rest(s__13328__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__13330),null);
}
} else {
var lz = cljs.core.first(s__13328__$2);
return cljs.core.cons(awesome_app.core.term_errors((function (){var G__13336 = (((side1 instanceof cljs.core.Keyword))?side1.fqn:null);
switch (G__13336) {
case "left":
return cljs.core._conj((function (){var x__7050__auto__ = side1_term;
return cljs.core._conj((function (){var x__7050__auto____$1 = lz;
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);

break;
case "right":
return cljs.core._conj((function (){var x__7050__auto__ = lz;
return cljs.core._conj((function (){var x__7050__auto____$1 = side1_term;
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(side1)].join('')));

}
})(),parent_constraints),awesome_app$core$side2_constraints_$_iter__13327(cljs.core.rest(s__13328__$2)));
}
} else {
return null;
}
break;
}
});})(sz,g))
,null,null));
});})(sz,g))
;
return iter__6996__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(sz));
})();
var errors_for_assignments = cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.map,cljs.core.vector,error_sequences);
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (g,error_sequences,errors_for_assignments){
return (function (errors){
return cljs.core.set(cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.second,cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (g,error_sequences,errors_for_assignments){
return (function (p1__13316_SHARP_){
return (cljs.core.first(p1__13316_SHARP_) === (0));
});})(g,error_sequences,errors_for_assignments))
,cljs.core.map.cljs$core$IFn$_invoke$arity$3(cljs.core.vector,errors,cljs.core.iterate(cljs.core.inc,(0))))));
});})(g,error_sequences,errors_for_assignments))
,errors_for_assignments);
});
/**
 * Returns a sequence of acceptable values (constraints) for each binding list in
 *   lexicographic order of xyz (with z varying the most quickly), relative to the
 *   specified overall constraints, for the specified side as the first side to be filled
 *   in -- meaning that for each binding list some value for the other side will 
 *   produce correct results when combined with these 'acceptable' values.
 */
awesome_app.core.side1_constraints = (function awesome_app$core$side1_constraints(side1,constraints){
var g = cljs.core.cst$kw$groupoid.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params)));
var constraints_for_constants = (function (){var iter__6996__auto__ = ((function (g){
return (function awesome_app$core$side1_constraints_$_iter__13350(s__13351){
return (new cljs.core.LazySeq(null,((function (g){
return (function (){
var s__13351__$1 = s__13351;
while(true){
var temp__4657__auto__ = cljs.core.seq(s__13351__$1);
if(temp__4657__auto__){
var s__13351__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_(s__13351__$2)){
var c__6994__auto__ = cljs.core.chunk_first(s__13351__$2);
var size__6995__auto__ = cljs.core.count(c__6994__auto__);
var b__13353 = cljs.core.chunk_buffer(size__6995__auto__);
if((function (){var i__13352 = (0);
while(true){
if((i__13352 < size__6995__auto__)){
var const$ = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__6994__auto__,i__13352);
cljs.core.chunk_append(b__13353,awesome_app.core.side2_constraints((function (){var G__13358 = (((side1 instanceof cljs.core.Keyword))?side1.fqn:null);
switch (G__13358) {
case "left":
return cljs.core.cst$kw$right;

break;
case "right":
return cljs.core.cst$kw$left;

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(side1)].join('')));

}
})(),const$,constraints));

var G__13361 = (i__13352 + (1));
i__13352 = G__13361;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__13353),awesome_app$core$side1_constraints_$_iter__13350(cljs.core.chunk_rest(s__13351__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__13353),null);
}
} else {
var const$ = cljs.core.first(s__13351__$2);
return cljs.core.cons(awesome_app.core.side2_constraints((function (){var G__13359 = (((side1 instanceof cljs.core.Keyword))?side1.fqn:null);
switch (G__13359) {
case "left":
return cljs.core.cst$kw$right;

break;
case "right":
return cljs.core.cst$kw$left;

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(side1)].join('')));

}
})(),const$,constraints),awesome_app$core$side1_constraints_$_iter__13350(cljs.core.rest(s__13351__$2)));
}
} else {
return null;
}
break;
}
});})(g))
,null,null));
});})(g))
;
return iter__6996__auto__(cljs.core.range.cljs$core$IFn$_invoke$arity$1(cljs.core.count(g)));
})();
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.map,clojure.set.union,constraints_for_constants);
});
/**
 * If there is a minimal solution for the given constraints in (:minimals @params)
 *   then this will return a random one of them. Otherwise this returns nil.
 */
awesome_app.core.minimal_solution = (function awesome_app$core$minimal_solution(constraints){
return cljs.core.some((function (p1__13363_SHARP_){
if((cljs.core.reduce.cljs$core$IFn$_invoke$arity$2(cljs.core._PLUS_,awesome_app.core.term_errors(p1__13363_SHARP_,constraints)) === (0))){
return p1__13363_SHARP_;
} else {
return false;
}
}),cljs.core.shuffle(cljs.core.cst$kw$minimals.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params)))));
});
/**
 * Searches for and returns a term that satisfies the given top-level-constraints.
 */
awesome_app.core.drill = (function awesome_app$core$drill(top_level_constraints){
var stack = (function (){var x__7050__auto__ = new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$constraints,top_level_constraints], null);
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto__);
})();
while(true){
var map__13367 = cljs.core.first(stack);
var map__13367__$1 = ((((!((map__13367 == null)))?((((map__13367.cljs$lang$protocol_mask$partition0$ & (64))) || (map__13367.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__13367):map__13367);
var constraints = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__13367__$1,cljs.core.cst$kw$constraints);
var left = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__13367__$1,cljs.core.cst$kw$left);
var right = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__13367__$1,cljs.core.cst$kw$right);
if(cljs.core.truth_((function (){var and__6204__auto__ = left;
if(cljs.core.truth_(and__6204__auto__)){
return right;
} else {
return and__6204__auto__;
}
})())){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(stack),(1))){
return cljs.core._conj((function (){var x__7050__auto__ = left;
return cljs.core._conj((function (){var x__7050__auto____$1 = right;
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_);
} else {
var parent = cljs.core.second(stack);
var solution_side = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$left.cljs$core$IFn$_invoke$arity$1(parent),cljs.core.cst$kw$computing))?cljs.core.cst$kw$left:cljs.core.cst$kw$right);
var G__13370 = cljs.core.cons(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(parent,solution_side,cljs.core._conj((function (){var x__7050__auto__ = left;
return cljs.core._conj((function (){var x__7050__auto____$1 = right;
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),x__7050__auto__);
})(),cljs.core.cst$sym$_STAR_)),cljs.core.rest(cljs.core.rest(stack)));
stack = G__13370;
continue;
}
} else {
if(cljs.core.not((function (){var or__6216__auto__ = left;
if(cljs.core.truth_(or__6216__auto__)){
return or__6216__auto__;
} else {
return right;
}
})())){
var temp__4655__auto__ = awesome_app.core.minimal_solution(constraints);
if(cljs.core.truth_(temp__4655__auto__)){
var ms = temp__4655__auto__;
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(stack),(1))){
return ms;
} else {
var parent = cljs.core.second(stack);
var solution_side = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$left.cljs$core$IFn$_invoke$arity$1(parent),cljs.core.cst$kw$computing))?cljs.core.cst$kw$left:cljs.core.cst$kw$right);
var G__13371 = cljs.core.cons(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(parent,solution_side,ms),cljs.core.rest(cljs.core.rest(stack)));
stack = G__13371;
continue;
}
} else {
var computing_side = cljs.core.rand_nth(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$left,cljs.core.cst$kw$right], null));
var G__13372 = cljs.core.cons(new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$constraints,awesome_app.core.side1_constraints(computing_side,constraints)], null),cljs.core.cons(cljs.core.PersistentArrayMap.fromArray([cljs.core.cst$kw$constraints,constraints,computing_side,cljs.core.cst$kw$computing], true, false),cljs.core.rest(stack)));
stack = G__13372;
continue;
}
} else {
var solved_side = (cljs.core.truth_(left)?cljs.core.cst$kw$left:cljs.core.cst$kw$right);
var remaining_side = (cljs.core.truth_(left)?cljs.core.cst$kw$right:cljs.core.cst$kw$left);
var solution = (function (){var G__13369 = (((solved_side instanceof cljs.core.Keyword))?solved_side.fqn:null);
switch (G__13369) {
case "left":
return left;

break;
case "right":
return right;

break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(solved_side)].join('')));

}
})();
var G__13374 = cljs.core.cons(new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$constraints,awesome_app.core.side2_constraints(solved_side,solution,constraints)], null),cljs.core.cons(cljs.core.PersistentArrayMap.fromArray([cljs.core.cst$kw$constraints,constraints,remaining_side,cljs.core.cst$kw$computing,solved_side,solution], true, false),cljs.core.rest(stack)));
stack = G__13374;
continue;
}
}
break;
}
});
awesome_app.core.generate_minimals = (function awesome_app$core$generate_minimals(){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(awesome_app.core.params,(function (p){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p,cljs.core.cst$kw$minimals,(function (){var num_minimals = cljs.core.reduce.cljs$core$IFn$_invoke$arity$2(cljs.core._PLUS_,cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__13375_SHARP_){
return (Math.pow((3),p1__13375_SHARP_) | (0));
}),cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.inc,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$max_DASH_length_DASH_of_DASH_minimals.cljs$core$IFn$_invoke$arity$1(p)))));
var index = (0);
var minimals = cljs.core.PersistentVector.EMPTY;
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(minimals),num_minimals)){
return minimals;
} else {
var G__13377 = (index + (1));
var G__13378 = (function (){var t = awesome_app.core.indexed_term(index);
if((cljs.core.count(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (index,minimals,t,num_minimals){
return (function (p1__13376_SHARP_){
return cljs.core.some(cljs.core.PersistentHashSet.fromArray([p1__13376_SHARP_], true),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$sym$y,null,cljs.core.cst$sym$x,null,cljs.core.cst$sym$z,null], null), null));
});})(index,minimals,t,num_minimals))
,cljs.core.flatten(t))) <= cljs.core.cst$kw$max_DASH_length_DASH_of_DASH_minimals.cljs$core$IFn$_invoke$arity$1(p))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(minimals,t);
} else {
return minimals;
}
})();
index = G__13377;
minimals = G__13378;
continue;
}
break;
}
})());
}));
});
awesome_app.core.prefix__GT_infix = (function awesome_app$core$prefix__GT_infix(t){
if((t instanceof cljs.core.Symbol)){
return t;
} else {
var x__7050__auto__ = awesome_app$core$prefix__GT_infix(cljs.core.nth.cljs$core$IFn$_invoke$arity$2(t,(1)));
return cljs.core._conj(cljs.core._conj((function (){var x__7050__auto____$1 = awesome_app$core$prefix__GT_infix(cljs.core.nth.cljs$core$IFn$_invoke$arity$2(t,(2)));
return cljs.core._conj(cljs.core.List.EMPTY,x__7050__auto____$1);
})(),cljs.core.cst$sym$_STAR_),x__7050__auto__);
}
});
awesome_app.core.default_params = new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$groupoid,awesome_app.core.a1,cljs.core.cst$kw$constraint_DASH_function,awesome_app.core.discriminator_constraints,cljs.core.cst$kw$max_DASH_length_DASH_of_DASH_minimals,(4),cljs.core.cst$kw$number_DASH_of_DASH_runs,(1)], null);
awesome_app.core.params = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(awesome_app.core.default_params) : cljs.core.atom.call(null,awesome_app.core.default_params));
awesome_app.core.output_buffer = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1("") : cljs.core.atom.call(null,""));
awesome_app.core.outputln = (function awesome_app$core$outputln(var_args){
var args__7298__auto__ = [];
var len__7291__auto___13384 = arguments.length;
var i__7292__auto___13385 = (0);
while(true){
if((i__7292__auto___13385 < len__7291__auto___13384)){
args__7298__auto__.push((arguments[i__7292__auto___13385]));

var G__13386 = (i__7292__auto___13385 + (1));
i__7292__auto___13385 = G__13386;
continue;
} else {
}
break;
}

var argseq__7299__auto__ = ((((0) < args__7298__auto__.length))?(new cljs.core.IndexedSeq(args__7298__auto__.slice((0)),(0),null)):null);
return awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(argseq__7299__auto__);
});

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic = (function (args){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(awesome_app.core.output_buffer,cljs.core.str,[cljs.core.str(cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.interleave.cljs$core$IFn$_invoke$arity$2(args,cljs.core.repeat.cljs$core$IFn$_invoke$arity$1(" ")))),cljs.core.str("\n")].join(''));
});

awesome_app.core.outputln.cljs$lang$maxFixedArity = (0);

awesome_app.core.outputln.cljs$lang$applyTo = (function (seq13383){
return awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq13383));
});
/**
 * Conduct a term search, printing a report to standard output, using the 
 *   parameters in params except where overriden by provided arguments.
 */
awesome_app.core.termsearch = (function awesome_app$core$termsearch(var_args){
var args__7298__auto__ = [];
var len__7291__auto___13392 = arguments.length;
var i__7292__auto___13393 = (0);
while(true){
if((i__7292__auto___13393 < len__7291__auto___13392)){
args__7298__auto__.push((arguments[i__7292__auto___13393]));

var G__13394 = (i__7292__auto___13393 + (1));
i__7292__auto___13393 = G__13394;
continue;
} else {
}
break;
}

var argseq__7299__auto__ = ((((0) < args__7298__auto__.length))?(new cljs.core.IndexedSeq(args__7298__auto__.slice((0)),(0),null)):null);
return awesome_app.core.termsearch.cljs$core$IFn$_invoke$arity$variadic(argseq__7299__auto__);
});

awesome_app.core.termsearch.cljs$core$IFn$_invoke$arity$variadic = (function (args){
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(awesome_app.core.output_buffer,"") : cljs.core.reset_BANG_.call(null,awesome_app.core.output_buffer,""));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["Here are the vals of the input map: ",cljs.core.vals(awesome_app.core.rs(cljs.core.first(args)))], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== termsearch started ==="], 0));

var G__13390_13395 = awesome_app.core.params;
var G__13391_13396 = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([awesome_app.core.default_params,cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,args)], 0));
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__13390_13395,G__13391_13396) : cljs.core.reset_BANG_.call(null,G__13390_13395,G__13391_13396));

awesome_app.core.generate_minimals();

if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$constraint_DASH_function.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params))),cljs.core.cst$kw$random_DASH_constraints)){
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== beginning random constraints run ==="], 0));

var random_terms_13397 = cljs.core.vec(cljs.core.repeatedly.cljs$core$IFn$_invoke$arity$2((10),(function (){
return awesome_app.core.bud_term((100));
})));
var term_ops_13398 = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(awesome_app.core.term_operation,random_terms_13397);
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["Random terms:",random_terms_13397], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["Term operations:",term_ops_13398], 0));

var n__7131__auto___13399 = cljs.core.count(term_ops_13398);
var run_13400 = (0);
while(true){
if((run_13400 < n__7131__auto___13399)){
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== starting run",run_13400,"==="], 0));

var constraints_13401 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_set,cljs.core.nth.cljs$core$IFn$_invoke$arity$2(term_ops_13398,run_13400));
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["constraints:",constraints_13401], 0));

var start_time_13402 = awesome_app.core.now();
var t_13403 = awesome_app.core.drill(constraints_13401);
var total_time_13404 = (awesome_app.core.now() - start_time_13402);
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["infix:",cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [" ",null], null), null),[cljs.core.str(awesome_app.core.prefix__GT_infix(t_13403))].join('')))], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["variables:",cljs.core.count(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (run_13400,start_time_13402,t_13403,total_time_13404,constraints_13401,n__7131__auto___13399,random_terms_13397,term_ops_13398){
return (function (p1__13387_SHARP_){
return !(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(p1__13387_SHARP_,"*"));
});})(run_13400,start_time_13402,t_13403,total_time_13404,constraints_13401,n__7131__auto___13399,random_terms_13397,term_ops_13398))
,cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [" ",null,"(",null,")",null], null), null),[cljs.core.str(t_13403)].join('')))))], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["runtime (ms):",total_time_13404], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== run",run_13400,"completed ==="], 0));

var G__13405 = (run_13400 + (1));
run_13400 = G__13405;
continue;
} else {
}
break;
}
} else {
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["constraints:",cljs.core.cst$kw$constraint_DASH_function.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params))).call(null,cljs.core.cst$kw$groupoid.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params))))], 0));

var n__7131__auto___13406 = cljs.core.cst$kw$number_DASH_of_DASH_runs.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params)));
var run_13407 = (0);
while(true){
if((run_13407 < n__7131__auto___13406)){
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== starting run",run_13407,"==="], 0));

var start_time_13408 = awesome_app.core.now();
var t_13409 = awesome_app.core.drill(cljs.core.cst$kw$constraint_DASH_function.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params))).call(null,cljs.core.cst$kw$groupoid.cljs$core$IFn$_invoke$arity$1((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.params) : cljs.core.deref.call(null,awesome_app.core.params)))));
var total_time_13410 = (awesome_app.core.now() - start_time_13408);
awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["infix:",cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [" ",null], null), null),[cljs.core.str(awesome_app.core.prefix__GT_infix(t_13409))].join('')))], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["variables:",cljs.core.count(cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (run_13407,start_time_13408,t_13409,total_time_13410,n__7131__auto___13406){
return (function (p1__13388_SHARP_){
return !(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(p1__13388_SHARP_,"*"));
});})(run_13407,start_time_13408,t_13409,total_time_13410,n__7131__auto___13406))
,cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.str,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [" ",null,"(",null,")",null], null), null),[cljs.core.str(t_13409)].join('')))))], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["runtime (ms):",total_time_13410], 0));

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== run",run_13407,"completed ==="], 0));

var G__13411 = (run_13407 + (1));
run_13407 = G__13411;
continue;
} else {
}
break;
}
}

awesome_app.core.outputln.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq(["=== all runs completed ==="], 0));

return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(awesome_app.core.output_buffer) : cljs.core.deref.call(null,awesome_app.core.output_buffer));
});

awesome_app.core.termsearch.cljs$lang$maxFixedArity = (0);

awesome_app.core.termsearch.cljs$lang$applyTo = (function (seq13389){
return awesome_app.core.termsearch.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq13389));
});
awesome_app.core.accept_input = (function awesome_app$core$accept_input(var_args){
var args__7298__auto__ = [];
var len__7291__auto___13416 = arguments.length;
var i__7292__auto___13417 = (0);
while(true){
if((i__7292__auto___13417 < len__7291__auto___13416)){
args__7298__auto__.push((arguments[i__7292__auto___13417]));

var G__13418 = (i__7292__auto___13417 + (1));
i__7292__auto___13417 = G__13418;
continue;
} else {
}
break;
}

var argseq__7299__auto__ = ((((1) < args__7298__auto__.length))?(new cljs.core.IndexedSeq(args__7298__auto__.slice((1)),(0),null)):null);
return awesome_app.core.accept_input.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7299__auto__);
});

awesome_app.core.accept_input.cljs$core$IFn$_invoke$arity$variadic = (function (s,p__13414){
var vec__13415 = p__13414;
var db = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__13415,(0),null);
return awesome_app.core.termsearch.cljs$core$IFn$_invoke$arity$variadic(cljs.core.array_seq([s], 0));
});

awesome_app.core.accept_input.cljs$lang$maxFixedArity = (1);

awesome_app.core.accept_input.cljs$lang$applyTo = (function (seq13412){
var G__13413 = cljs.core.first(seq13412);
var seq13412__$1 = cljs.core.next(seq13412);
return awesome_app.core.accept_input.cljs$core$IFn$_invoke$arity$variadic(G__13413,seq13412__$1);
});
