// Compiled by ClojureScript 1.9.14 {:static-fns true, :optimize-constants true}
goog.provide('reagent.dom');
goog.require('cljs.core');
goog.require('reagent.impl.util');
goog.require('reagent.impl.template');
goog.require('reagent.ratom');
goog.require('reagent.debug');
goog.require('reagent.interop');
if(typeof reagent.dom.imported !== 'undefined'){
} else {
reagent.dom.imported = null;
}
reagent.dom.module = (function reagent$dom$module(){
if(cljs.core.some_QMARK_(reagent.dom.imported)){
return reagent.dom.imported;
} else {
if(typeof ReactDOM !== 'undefined'){
return reagent.dom.imported = ReactDOM;
} else {
if(typeof require !== 'undefined'){
var or__6216__auto__ = reagent.dom.imported = require("react-dom");
if(cljs.core.truth_(or__6216__auto__)){
return or__6216__auto__;
} else {
throw (new Error("require('react-dom') failed"));
}
} else {
throw (new Error("js/ReactDOM is missing"));

}
}
}
});
if(typeof reagent.dom.roots !== 'undefined'){
} else {
reagent.dom.roots = (function (){var G__12678 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__12678) : cljs.core.atom.call(null,G__12678));
})();
}
reagent.dom.unmount_comp = (function reagent$dom$unmount_comp(container){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(reagent.dom.roots,cljs.core.dissoc,container);

return (reagent.dom.module()["unmountComponentAtNode"])(container);
});
reagent.dom.render_comp = (function reagent$dom$render_comp(comp,container,callback){
var _STAR_always_update_STAR_12681 = reagent.impl.util._STAR_always_update_STAR_;
reagent.impl.util._STAR_always_update_STAR_ = true;

try{return (reagent.dom.module()["render"])((comp.cljs$core$IFn$_invoke$arity$0 ? comp.cljs$core$IFn$_invoke$arity$0() : comp.call(null)),container,((function (_STAR_always_update_STAR_12681){
return (function (){
var _STAR_always_update_STAR_12682 = reagent.impl.util._STAR_always_update_STAR_;
reagent.impl.util._STAR_always_update_STAR_ = false;

try{cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(reagent.dom.roots,cljs.core.assoc,container,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [comp,container], null));

if(cljs.core.some_QMARK_(callback)){
return (callback.cljs$core$IFn$_invoke$arity$0 ? callback.cljs$core$IFn$_invoke$arity$0() : callback.call(null));
} else {
return null;
}
}finally {reagent.impl.util._STAR_always_update_STAR_ = _STAR_always_update_STAR_12682;
}});})(_STAR_always_update_STAR_12681))
);
}finally {reagent.impl.util._STAR_always_update_STAR_ = _STAR_always_update_STAR_12681;
}});
reagent.dom.re_render_component = (function reagent$dom$re_render_component(comp,container){
return reagent.dom.render_comp(comp,container,null);
});
/**
 * Render a Reagent component into the DOM. The first argument may be
 *   either a vector (using Reagent's Hiccup syntax), or a React element. The second argument should be a DOM node.
 * 
 *   Optionally takes a callback that is called when the component is in place.
 * 
 *   Returns the mounted component instance.
 */
reagent.dom.render = (function reagent$dom$render(var_args){
var args12683 = [];
var len__7291__auto___12686 = arguments.length;
var i__7292__auto___12687 = (0);
while(true){
if((i__7292__auto___12687 < len__7291__auto___12686)){
args12683.push((arguments[i__7292__auto___12687]));

var G__12688 = (i__7292__auto___12687 + (1));
i__7292__auto___12687 = G__12688;
continue;
} else {
}
break;
}

var G__12685 = args12683.length;
switch (G__12685) {
case 2:
return reagent.dom.render.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return reagent.dom.render.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12683.length)].join('')));

}
});

reagent.dom.render.cljs$core$IFn$_invoke$arity$2 = (function (comp,container){
return reagent.dom.render.cljs$core$IFn$_invoke$arity$3(comp,container,null);
});

reagent.dom.render.cljs$core$IFn$_invoke$arity$3 = (function (comp,container,callback){
reagent.ratom.flush_BANG_();

var f = (function (){
return reagent.impl.template.as_element(((cljs.core.fn_QMARK_(comp))?(comp.cljs$core$IFn$_invoke$arity$0 ? comp.cljs$core$IFn$_invoke$arity$0() : comp.call(null)):comp));
});
return reagent.dom.render_comp(f,container,callback);
});

reagent.dom.render.cljs$lang$maxFixedArity = 3;
reagent.dom.unmount_component_at_node = (function reagent$dom$unmount_component_at_node(container){
return reagent.dom.unmount_comp(container);
});
/**
 * Returns the root DOM node of a mounted component.
 */
reagent.dom.dom_node = (function reagent$dom$dom_node(this$){
return (reagent.dom.module()["findDOMNode"])(this$);
});
reagent.impl.template.find_dom_node = reagent.dom.dom_node;
/**
 * Force re-rendering of all mounted Reagent components. This is
 *   probably only useful in a development environment, when you want to
 *   update components in response to some dynamic changes to code.
 * 
 *   Note that force-update-all may not update root components. This
 *   happens if a component 'foo' is mounted with `(render [foo])` (since
 *   functions are passed by value, and not by reference, in
 *   ClojureScript). To get around this you'll have to introduce a layer
 *   of indirection, for example by using `(render [#'foo])` instead.
 */
reagent.dom.force_update_all = (function reagent$dom$force_update_all(){
reagent.ratom.flush_BANG_();

var seq__12694_12698 = cljs.core.seq(cljs.core.vals((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(reagent.dom.roots) : cljs.core.deref.call(null,reagent.dom.roots))));
var chunk__12695_12699 = null;
var count__12696_12700 = (0);
var i__12697_12701 = (0);
while(true){
if((i__12697_12701 < count__12696_12700)){
var v_12702 = chunk__12695_12699.cljs$core$IIndexed$_nth$arity$2(null,i__12697_12701);
cljs.core.apply.cljs$core$IFn$_invoke$arity$2(reagent.dom.re_render_component,v_12702);

var G__12703 = seq__12694_12698;
var G__12704 = chunk__12695_12699;
var G__12705 = count__12696_12700;
var G__12706 = (i__12697_12701 + (1));
seq__12694_12698 = G__12703;
chunk__12695_12699 = G__12704;
count__12696_12700 = G__12705;
i__12697_12701 = G__12706;
continue;
} else {
var temp__4657__auto___12707 = cljs.core.seq(seq__12694_12698);
if(temp__4657__auto___12707){
var seq__12694_12708__$1 = temp__4657__auto___12707;
if(cljs.core.chunked_seq_QMARK_(seq__12694_12708__$1)){
var c__7027__auto___12709 = cljs.core.chunk_first(seq__12694_12708__$1);
var G__12710 = cljs.core.chunk_rest(seq__12694_12708__$1);
var G__12711 = c__7027__auto___12709;
var G__12712 = cljs.core.count(c__7027__auto___12709);
var G__12713 = (0);
seq__12694_12698 = G__12710;
chunk__12695_12699 = G__12711;
count__12696_12700 = G__12712;
i__12697_12701 = G__12713;
continue;
} else {
var v_12714 = cljs.core.first(seq__12694_12708__$1);
cljs.core.apply.cljs$core$IFn$_invoke$arity$2(reagent.dom.re_render_component,v_12714);

var G__12715 = cljs.core.next(seq__12694_12708__$1);
var G__12716 = null;
var G__12717 = (0);
var G__12718 = (0);
seq__12694_12698 = G__12715;
chunk__12695_12699 = G__12716;
count__12696_12700 = G__12717;
i__12697_12701 = G__12718;
continue;
}
} else {
}
}
break;
}

return "Updated";
});
